<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Komentar" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="comments" ref="commentTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Tanggal"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>    
            <el-table-column
                label="Modul"
                width="150">
                <template slot-scope="scope">
                    <span v-if="scope.row.info != null">Informasi</span>
                    <span v-else-if="scope.row.announcement != null">Pengumuman</span>
                    <span v-else-if="scope.row.residentreport != null">Laporan Warga</span>
                    <span v-else>Grup Panic</span>
                </template>
            </el-table-column>       
            <el-table-column
                label="Judul Informasi"
                width="300">
                <template slot-scope="scope">
                    <span v-if="scope.row.info != null">{{ scope.row.info.title }}</span>
                    <span v-else-if="scope.row.announcement != null">{{ scope.row.announcement.title }}</span>
                    <span v-else-if="scope.row.residentreport != null">{{ scope.row.residentreport.title }}</span>
                    <span v-else>{{ scope.row.panic.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Komentar"
                width="350">
                <template slot-scope="scope">
                    <span>{{ truncate(scope.row.comment) }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                label="Author"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.user.profile.fullname }}</span>
                </template>
            </el-table-column>
            <el-table-column
                align="center"
                label="Attachment"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.medias.length > 0 ? scope.row.medias.length : 0 }}</span>
                </template>
            </el-table-column>
            <el-table-column
                align="center"
                label="Lokasi"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.mapurl != null ? 'Ya' : ' - ' }}</span>
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'comment', 'viewother']" type="text" @click="handleView(row)">Lihat Komentar</el-button>
                    <el-button v-permission="[row, 'comment', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog title="Detil Komentar" :visible.sync="showDialog" width="30%" :show-close="false">
            <h3>{{ comment.title }}</h3>
            <el-alert
                type="info"
                :closable="false">
                <div slot="title">
                    <small class="display-block"><strong>Oleh: {{ comment.author }}, {{ comment.posted }}</strong></small>
                    <span class="display-block">{{ comment.comment }}</span>
                    <br>
                    <div class="block" v-if="comment.medias.length > 0" >
                        <el-image
                        v-for="media in comment.medias"
                        v-bind:key="media.id"
                        style="width: 100px; height: 100px"
                        :src="media.url.medium"
                        fit="fill"></el-image>
                    </div>
                    <div class="block" v-if="comment.mapurl != null" >
                        <el-image
                        style="width:100%"
                        :src="comment.mapurl"
                        fit="fill"></el-image>
                    </div>
                </div>
            </el-alert>
            
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Tutup</el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight, truncate } from '@/utils/index';

export default {
    name: 'Comment',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){
        return {
            tableLoading: false,
            showDialog: false,
            filter: {
                keyword: ''
            },
            comment: {
                title: '',
                comment: '',
                posted: '',
                author: '',
                mapurl: '',
                medias: []
            }
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('comment', ['comments', 'pagination']),
    },
    created() {
        this.getComments();
    },
    methods: {
        playSound,
        dateFormat,
        truncate,
        getComments() {
            this.tableLoading = true;
            this.$store.dispatch('comment/getComments', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            this.tableLoading = true;
            this.$store.dispatch('comment/getComments', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleView(comment){
            this.showDialog = true;
            
            if(comment.info != null){
                this.comment.title = comment.info.title
            }else if(comment.announcement != null){
                this.comment.title = comment.announcement.title;
            }else if(comment.residentreport != null){
                this.comment.title = comment.residentreport.title;
            }else{
                this.comment.title = comment.panic.name;
            }

            this.comment.comment = comment.comment;
            this.comment.author = comment.user.profile.fullname;
            this.comment.mapurl = comment.mapurl;
            this.comment.posted = dateFormat(comment.updated);
            this.comment.medias = comment.medias;

        },
        handleDelete(comment){
            this.$confirm('Anda mencoba untuk menghapus data komentar, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('comment/deleteComment', {
                    id: comment.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
    }

}
</script>
